﻿using Models;
using Stub;
using DataContractPersistance;
using GameAtlas.Views;

namespace GameAtlas;

/// <summary>
/// Classe partielle pour l'application principale.
/// </summary>
public partial class App : Application
{
    /// <summary>
    /// Nom du fichier de données.
    /// </summary>
    public string FileName { get; set; } = "data.json"; // data.xml

    /// <summary>
    /// Chemin du fichier de données.
    /// </summary>
    public string FilePath { get; set; } = Path.Combine(AppDomain.CurrentDomain.BaseDirectory);

    /// <summary>
    /// Gestionnaire principal de l'application.
    /// </summary>
    public Manager MyManager { get; private set; } = new Manager(new Stub.Stub());//new Manager(new DataContractPersistance.DataContractPers());

    /// <summary>
    /// Constructeur de l'application.
    /// </summary>
    public App()
	{
        InitializeComponent();

        if (File.Exists(Path.Combine(FilePath, FileName)))
		{
			//MyManager = new Manager(new DataContractPersistance.DataContractXML());
            MyManager = new Manager(new DataContractPersistance.DataContractJSON());
		}


        MyManager.ChargerDonnees();

        MainPage = new AppShell();


        if (!File.Exists(Path.Combine(FilePath, FileName)))
        {
            //MyManager.Persistance = new DataContractPersistance.DataContractXML();
            MyManager.Persistance = new DataContractPersistance.DataContractJSON();
        }


		MyManager.SauvegardeDonnees();
	}
}
