﻿using CommunityToolkit.Maui;
using Microsoft.Extensions.Logging;

namespace GameAtlas;

/// <summary>
/// Classe principale du programme pour l'application Maui.
/// </summary>
public static class MauiProgram
{
    /// <summary>
    /// Crée et configure l'application MAUI.
    /// </summary>
    /// <returns>L'application MAUI configurée.</returns>
    public static MauiApp CreateMauiApp()
	{
		var builder = MauiApp.CreateBuilder();
		builder
			.UseMauiApp<App>()
            .UseMauiCommunityToolkit()
            .ConfigureFonts(fonts =>
			{
				// Open Sans
				fonts.AddFont("OpenSans-Regular.ttf", "OpenSansRegular");
				fonts.AddFont("OpenSans-Semibold.ttf", "OpenSansSemibold");

                fonts.AddFont("Aladin-Regular.ttf", "AladinRegular");

                fonts.AddFont("PTSansCaption-Regular.ttf", "PTSansCRegular");
                fonts.AddFont("PTSansCaption-Bold.ttf", "PTSansCBold");

                fonts.AddFont("PTSansNarrow-Regular.ttf", "PTSansNRegular");
                fonts.AddFont("PTSansNarrow-Bold.ttf", "PTSansNBold");

                fonts.AddFont("Roboto-Regular.ttf", "RobotoRegular");
				fonts.AddFont("Roboto-Bold.ttf", "RobotoBold");
				fonts.AddFont("Roboto-Black.ttf", "RobotoBlack");
            });

#if DEBUG
		builder.Logging.AddDebug();
#endif

		return builder.Build();
	}
}
