﻿using Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Tests
{
    public class JeuCreation
    {
        [Fact]
        public void Jeu_Creation_Et_Verification()
        {
            
            string nom = "Street Fighter 6";
            string resume = "Un jeu de combat";
            string sortie = "2 Juin 2023";
            string plateformes = "PC Xbox PlayStation";
            string developpeur = "CAPCOM Co., Ltd.";
            string editeur = "Capcom";
            double note = 4.5;
            int nbTelechargement = 1200;
            string genres = "Action Aventure";
            string image = "test_image.png";

            
            Jeu jeu = new Jeu(nom, resume, sortie, plateformes, developpeur, editeur, note, nbTelechargement, genres, image);
            List<string> listPlateformes = plateformes.Split(' ').ToList();
            List<string> listGenres = genres.Split(' ').ToList();


            // Assert
            Assert.Equal(nom, jeu.Nom);
            Assert.Equal(resume, jeu.Resume);
            Assert.Equal(sortie, jeu.Sortie);
            Assert.Equal(listPlateformes, jeu.ListPlateformes);
            Assert.Equal(developpeur, jeu.Developpeur);
            Assert.Equal(editeur, jeu.Editeur);
            Assert.Equal(note, jeu.Note);
            Assert.Equal(nbTelechargement, jeu.NbTelechargement);
            Assert.Equal(listGenres, jeu.ListGenres);
            Assert.Equal(image, jeu.Image);
            Assert.Empty(jeu.ListAvis);
            Assert.Equal(0, jeu.NbFavoris);
            Assert.Equal(0, jeu.NbPossedes);
        }

        [Fact]
        public void Jeu_AjouterAvis()
        {

            string nom = "Street Fighter 6";
            string resume = "Un jeu de combat";
            string sortie = "2 Juin 2023";
            string plateformes = "PC Xbox PlayStation";
            string developpeur = "CAPCOM Co., Ltd.";
            string editeur = "Capcom";
            double note = 4.5;
            int nbTelechargement = 1200;
            string genres = "Action Aventure";
            string image = "test_image.png";

            Jeu jeu = new Jeu(nom, resume, sortie, plateformes, developpeur, editeur, note, nbTelechargement, genres, image);
            
            string pseudo = "John";
            double notation = 8.6;
            string commentaire = "Jeu mangifique !";

            
            jeu.AjouterAvis(pseudo, notation, commentaire);

            // Assert
            Assert.Single(jeu.ListAvis);
            var avis = jeu.ListAvis[0];
            Assert.Equal(pseudo, avis.Item1);
            Assert.Equal(notation, avis.Item2);
            Assert.Equal(commentaire, avis.Item3);
        }

        [Fact]
        public void Jeu_Comparer()
        {
            
            Jeu jeu1 = new Jeu("Un Jeu", "Description", "1 Janvier 2023", "PC", "Studio", "Editeur", 4.5, 1000, "Action", "test_image.png");
            Jeu jeu2 = new Jeu("Un Jeu", "Description", "1 Janvier 2023", "PC", "Studio", "Editeur", 4.5, 1000, "Action", "test_image.png");
            Jeu jeu3 = new Jeu("Un autre Jeu", "Une autre description", "12 Janvier 2023", "PS5", "Studio", "Autre Editeur", 3.8, 500, "Aventure", "test_image.png");
            Jeu jeu4 = new Jeu("Un autre Jeu", "Une autre description", "1 Janvier 2023", "PS5", "Studio", "Autre Editeur", 3.8, 500, "Aventure", "test_image.png");

            // Assert
            Assert.Equal(jeu1, jeu2);
            Assert.NotEqual(jeu1, jeu3);
            Assert.NotEqual(jeu2, jeu3);
            Assert.NotEqual(jeu1, jeu4);
        }
    }
}
